import type { Writable } from 'svelte/store';
import type { ObjectSchema } from 'yup';
declare type FormState = {
    [key: string]: {
        _touched?: boolean;
        _errors?: string[];
        [key: string]: any;
    };
};
declare type CSSConfig = {
    enabled?: boolean;
    validClass?: string;
    invalidClass?: string;
    useValid?: boolean;
    useInvalid?: boolean;
};
declare type FormConfigInput<Data = any> = {
    values: Data;
    validationSchema?: ObjectSchema<any>;
    css?: CSSConfig;
    validateOnChange?: boolean;
    validateOnBlur?: boolean;
};
export declare function createForm<Data>({ values: initialValues, validationSchema, css: cssConfig, validateOnChange, validateOnBlur }: FormConfigInput<Data>): {
    values: Writable<Data>;
    state: Writable<FormState>;
    isValid: Writable<boolean>;
    isTouched: Writable<boolean>;
    validateForm: (highlight?: 'none' | 'errors' | 'all') => void;
    handleChange: (event: Event) => void;
    updateForm: () => Promise<void>;
    setTouched: (state: boolean) => void;
    highlight: (node: HTMLElement & {
        name: string;
    }, options?: CSSConfig) => {
        destroy(): void;
    };
    resetForm: (newValue?: Data) => void;
};
export {};
